/* ----------------------------------------------------------------------------
 * Copyright (c) 2015-2017 Semiconductor Components Industries, LLC (d/b/a
 * ON Semiconductor), All Rights Reserved
 *
 * Copyright (C) RivieraWaves 2009-2016
 *
 * This module is derived in part from example code provided by RivieraWaves
 * and as such the underlying code is the property of RivieraWaves [a member
 * of the CEVA, Inc. group of companies], together with additional code which
 * is the property of ON Semiconductor. The code (in whole or any part) may not
 * be redistributed in any form without prior written permission from
 * ON Semiconductor.
 *
 * The terms of use and warranty for this code are covered by contractual
 * agreements between ON Semiconductor and the licensee.
 *
 * This is Reusable Code.
 *
 * This code has been altered by Rebecca Hoehne and Tansy Wang
 *
 * This project is based on the peripheral server UART example project
 *
 * ----------------------------------------------------------------------------
 * app.c
 * - Main application file
 * ----------------------------------------------------------------------------
 * $Revision: 1.24 $
 * $Date: 2017/12/04 22:53:32 $
 * ------------------------------------------------------------------------- */

#include "app.h"


int main(void)
{
    uint32_t length;
   // uint8_t temp[BUFFER_SIZE];
    uint32_t test;


    /* Initialize the system */
    App_Initialize();

    /* Main application loop:
     * - Run the kernel scheduler
     * - Send notifications for the battery voltage and RSSI values
     * - Refresh the watchdog and wait for an interrupt before continuing */
    while (1)
    {
        Kernel_Schedule();

        /* send the battery level update */

        if (ble_env.state == APPM_CONNECTED)
        {
//            if (app_env.send_batt_ntf && bass_support_env.enable)
//            {
//                app_env.send_batt_ntf = 0;
//                app_env.batt_lvl=(rand()%100-50)+50;
//                Batt_LevelUpdateSend(0, app_env.batt_lvl, 0);
//            }


			/* send the hydrowatch update */
			if (cs_env.send_hw_ntf && cs_env.enable && cs_env.hw1_cccd_value)
			{

				cs_env.send_hw_ntf = 0;
				cs_env.enable=0;

					/* call send notification function: found in ble_custom.c */
					CustomService_SendNotification(ble_env.conidx,
							CS_IDX_HW1_VALUE_VAL,&cs_env.hw1_value,4);
					CustomService_SendNotification(ble_env.conidx,
							CS_IDX_HW2_VALUE_VAL,&cs_env.hw2_value,4);
					CustomService_SendNotification(ble_env.conidx,
						   CS_IDX_HW3_VALUE_VAL,&cs_env.hw3_value,4);
					CustomService_SendNotification(ble_env.conidx,
					   CS_IDX_HW4_VALUE_VAL,&cs_env.hw4_value,4);


            }

        }
    }


        /* Refresh the watchdog timer */
        Sys_Watchdog_Refresh();

        /* Wait for an event before executing the scheduler again */
        SYS_WAIT_FOR_EVENT;

}


