/* ----------------------------------------------------------------------------
 * Copyright (c) 2015-2017 Semiconductor Components Industries, LLC (d/b/a
 * ON Semiconductor), All Rights Reserved
 *
 * Copyright (C) RivieraWaves 2009-2016
 *
 * This module is derived in part from example code provided by RivieraWaves
 * and as such the underlying code is the property of RivieraWaves [a member
 * of the CEVA, Inc. group of companies], together with additional code which
 * is the property of ON Semiconductor. The code (in whole or any part) may not
 * be redistributed in any form without prior written permission from
 * ON Semiconductor.
 *
 * The terms of use and warranty for this code are covered by contractual
 * agreements between ON Semiconductor and the licensee.
 *
 * This is Reusable Code.
 *
 * ----------------------------------------------------------------------------
 * app_process.c
 * - Application task handler definition and support processes
 * ----------------------------------------------------------------------------
 * $Revision: 1.9 $
 * $Date: 2017/12/05 16:02:54 $
 * ------------------------------------------------------------------------- */

#include "app.h"

//int BUTTONPRESSED=0;
//
//void DIO12_IRQHandler(void)
//{
//    static uint8_t ignore_next_dio_int = 0;
//    if (ignore_next_dio_int)
//    {
//        ignore_next_dio_int = 0;
//    }
//    else if ((DIO_DATA->ALIAS[BUTTON_DIO] == 0) && (!spi0->GetStatus().busy))
//    {
//        /* Button is pressed: Ignore next interrupt.
//         * This is required to deal with the debounce circuit limitations. */
//        ignore_next_dio_int = 1;
//        BUTTONPRESSED=1;
//
//        /* Activate SSEL line and start transfer on SPI0/master */
//        //spi0->Control(ARM_SPI_CONTROL_SS, ARM_SPI_SS_ACTIVE);
////        spi0->Transfer(SPI_TX_DATA,spi0_rx_buffer,  SPI_TRANSFER_COUNT);
//
//        //NEXT STEP: Setting up a loop within this interrupt to trigger readings
//        // execute writes on button press to make sure that we can run logic inside interrupts correctly
//        // get just two readings when the button is pressed
//        //then get the readings to happen for a set time and see if the readings make sense
//        //figure out timing between measurements and BLE stuff to maximize time spent in this loop
//        //hydration doesn't change that quickly, fewer measurements probably good enough
//
//
//
//
//    }
//}


const struct ke_task_desc TASK_DESC_APP = {
    NULL, &appm_default_handler,
    appm_state, APPM_STATE_MAX,
    APP_IDX_MAX
};

/* State and event handler definition */
const struct ke_msg_handler appm_default_state[] =
{
    /* Note: Put the default handler on top as this is used for handling any
     *       messages without a defined handler */
    { KE_MSG_DEFAULT_HANDLER, (ke_msg_func_t)Msg_Handler },
    BLE_MESSAGE_HANDLER_LIST,
   // BASS_MESSAGE_HANDLER_LIST,
    CS_MESSAGE_HANDLER_LIST,
    APP_MESSAGE_HANDLER_LIST,
    //UART_MESSAGE_HANDLER_LIST
};

/* Use the state and event handler definition for all states. */
const struct ke_state_handler appm_default_handler
    = KE_STATE_HANDLER(appm_default_state);

/* Defines a place holder for all task instance's state */
ke_state_t appm_state[APP_IDX_MAX];

/* Struct variable to hold white list related information */
struct ble_whitelist_info whitelist_info;




/* ----------------------------------------------------------------------------
 * Function      : int APP_Timer(ke_msg_idd_t const msg_id,
 *                                void const *param,
 *                                ke_task_id_t const dest_id,
 *                                ke_task_id_t const src_id)
 * ----------------------------------------------------------------------------
 * Description   : Handle timer event message
 * Inputs        : - msg_id     - Kernel message ID number
 *                 - param      - Message parameter (unused)
 *                 - dest_id    - Destination task ID number
 *                 - src_id     - Source task ID number
 * Outputs       : return value - Indicate if the message was consumed;
 *                                compare with KE_MSG_CONSUMED
 * Assumptions   : None
 * ------------------------------------------------------------------------- */
int APP_Timer(ke_msg_id_t const msg_id,
              void const *param,
              ke_task_id_t const dest_id,
              ke_task_id_t const src_id)
{
    uint16_t level;
    unsigned long output, output1, output2, output3, output4;
	long MSB, mSB, LSB, indent;
    /* Restart timer */
    ke_timer_set(APP_TEST_TIMER, TASK_APP, TIMER_200MS_SETTING);

    /* Every second report that the custom service HydroWatch value changed
     * every 1s
     * This parameters come into play in the ble_custom
     * (notification simulation) */
    app_env.cnt_notifc_hw++;
    if (app_env.cnt_notifc_hw == 1)
    {
        app_env.cnt_notifc_hw = 0;
        cs_env.hw_value_changed = 1;

//        /* send 6 byte random value, zero padded by 2 bytes */
//        long MSB, mSB, LSB,ident; //M=most, m-middle, L-least
//        output=(rand()%(16777215));
//        MSB=output>>16;
//        mSB=MSB>>8|output>>8;
//        LSB=MSB>>16|mSB>>8|output;
//
//        ident=(rand()%(4));
//
//		cs_env.hw1_value=output;
//
//		/* send notification */
//        cs_env.send_hw_ntf=1;
//
//
//		cs_env.hw_value_changed =0;
         unsigned char received1[4]; //receive buffer to get bytes from transfers
         unsigned char received2[4]; //receive buffer to get bytes from transfers
         unsigned char received3[4]; //receive buffer to get bytes from transfers
         unsigned char received4[4]; //receive buffer to get bytes from transfers

         int datacount=0;
         while (cs_env.hw_value_changed==1)
            {
        	 //if(BUTTONPRESSED==1){
        		 //while(datacount!=100){
        	 //led 1
        	 	AFEwrite2(0x00,0x000000);//put second AFE into register write mode
        	 	AFEwrite2(0x23,0x020500);//TRISTATE second AFE to not interfere with measurements
        	 	AFEreadmode();
            	AFEtransfer(0x2E,0x000000, received1); //2E
            	unsigned char something1[4]={0x00,received1[1],received1[2],received1[3]};
            	unsigned long firstread=0x10<<24|received1[1]<<16|received1[2]<<8|received1[3];
            	Sys_Delay_ProgramROM(0.0005 * SystemCoreClock);
            	output1=firstread;

           	 //led 2
				AFEtransfer(0x2F,0x000000, received2); //2F
				unsigned char something2[4]={0x00,received2[1],received2[2],received2[3]};
				unsigned long secondread=0x20<<24|received2[1]<<16|received2[2]<<8|received2[3];
				Sys_Delay_ProgramROM(0.0005 * SystemCoreClock);
				output2=secondread;
				AFEwrite2(0x23,0x020100);//undo TRISTATE on the second AFE so we can talk to it

 			//led 3
				AFEwrite(0x00,0x000000);//put first AFE into register write mode
				AFEwrite(0x23,0x020500);//TRISTATE the first AFE to not interfere with second AFE
				AFEreadmode2();
 				AFEtransfer2(0x2E,0x000000, received3); //2E
 				unsigned char something3[4]={0x00,received3[1],received3[2],received3[3]};
 				unsigned long thirdread=0x30<<24|received3[1]<<16|received3[2]<<8|received3[3];
 				Sys_Delay_ProgramROM(0.0005 * SystemCoreClock);
 				output3=thirdread;

 			//led 4
                	AFEtransfer2(0x2F,0x000000, received4); //2F
                	unsigned char something4[4]={0x00,received4[1],received4[2],received4[3]};
                	unsigned long fourthread=0x40<<24|received4[1]<<16|received4[2]<<8|received4[3];
                	Sys_Delay_ProgramROM(0.0005 * SystemCoreClock);
                	output4=fourthread;
                	AFEwrite(0x23,0x020100);//undo TRISATE on first AFE so we can talk to it again
                	//BUTTONPRESSED=0;
        	 //}






            	//AFEtransfer2(0x14,0x000000, received);
            	//unsigned char something2[4]={0x01,received[1],received[2],received[3]};//the read functions send out correctly here
            	//unsigned long secondread=0x40<<24|received[1]<<16|received[2]<<8|received[3];
            	//Sys_Delay_ProgramROM(0.0005 * SystemCoreClock);
            	//output2=secondread;
            	cs_env.hw_value_changed=0;

            }

          long MSB1, mSB1, LSB1,ident1,MSB2, mSB2, LSB2,ident2,MSB3, mSB3, LSB3,ident3,MSB4, mSB4, LSB4,ident4; //M=most, m-middle, L-least



		//led 1
          ident1=output1>>24;
          MSB1=ident1>>8|output1>>16;
          mSB1=ident1>>16|MSB1>>8|output1>>8;
          LSB1=ident1>>24|MSB1>>16|mSB1>>8|output1;


        //led2
          ident2=output2>>24;
          MSB2=ident2>>8|output2>>16;
          mSB2=ident2>>16|MSB2>>8|output2>>8;
          LSB2=ident2>>24|MSB2>>16|mSB2>>8|output2;


        //led3
          //output3=(rand()%(30-20)+20);
          ident3=output3>>24;
          MSB3=ident3>>8|output3>>16;
          mSB3=ident3>>16|MSB3>>8|output3>>8;
          LSB3=ident3>>24|MSB3>>16|mSB3>>8|output3;\

        //led4
          //output4=(rand()%(10));
          ident4=output4>>24;
          MSB4=ident4>>8|output4>>16;
          mSB4=ident4>>16|MSB4>>8|output4>>8;
          LSB4=ident4>>24|MSB4>>16|mSB4>>8|output4;


        /*When being sent the output is put out 2 bytes at a time in the buffer
         * and ends up being read out backwards so we have to invert
         * ie: 0x016725 will be sent to app as 0x256701 if we do not change it
         * thus we invert output to be 0x256701 so it is read out 0x016725  */

        output1=(LSB1<<24|(mSB1<<16)|(MSB1<<8)|ident1);
        output2=(LSB2<<24|(mSB2<<16)|(MSB2<<8)|ident2);
        output3=(LSB3<<24|(mSB3<<16)|(MSB3<<8)|ident3);
        output4=(LSB4<<24|(mSB4<<16)|(MSB4<<8)|ident4);


        cs_env.hw1_value=output1;
        cs_env.hw2_value=output2;
        cs_env.hw3_value=output3;
        cs_env.hw4_value=output4;


        /* send notification */
        cs_env.send_hw_ntf=1;
        //datacount=datacount+1;}//increment the number of data points counted}

            //}


    }

//    /* Calculate the battery level as a percentage, scaling the battery
//     * voltage between 1.4V (max) and 1.1V (min) */
//    level = ((ADC->DATA_TRIM_CH[0] - VBAT_1p1V_MEASURED) * 100
//             / (VBAT_1p4V_MEASURED - VBAT_1p1V_MEASURED));
//    level = ((level >= 100) ? 100 : level);
//
//    /* Add to the current sum and increment the number of reads,
//     * calculating the average over 16 voltage reads
//     * currently set up for battery level is not set up for notification*/
//    app_env.sum_batt_lvl += level;
//    app_env.num_batt_read++;
//    if (app_env.num_batt_read == 16)
//    {
//        if ((app_env.sum_batt_lvl >> 4) != app_env.batt_lvl)
//        {
//            app_env.send_batt_ntf = true;
//            app_env.batt_lvl = (app_env.sum_batt_lvl >> 4);
//        }
//
//        app_env.num_batt_read = 0;
//        app_env.sum_batt_lvl = 0;
//    }

    return (KE_MSG_CONSUMED);
}

/* ----------------------------------------------------------------------------
 * Function      : int LED_Timer(ke_msg_idd_t const msg_id,
 *                               void const *param,
 *                               ke_task_id_t const dest_id,
 *                               ke_task_id_t const src_id)
 * ----------------------------------------------------------------------------
 * Description   : Control GPIO "LED_DIO_NUM" behavior using a timer.
 *                 Possible LED behaviors:
 *                     - If the device has not started advertising: the LED
 *                       is off.
 *                     - If the device is advertising but it has not connected
 *                       to any peer: the LED blinks every 200 ms.
 *                     - If the device is advertising and it is connecting to
 *                       fewer than NUM_SLAVES peers: the LED blinks every 2
 *                       seconds according to the number of connected peers
 *                       (i.e., blinks once if one peer is connected, twice if
 *                       two peers are connected, etc.).
 *                     - If the device is connecting to NUM_SLAVES peers (it
 *                       stopped advertising): the LED is steady on.
 * Inputs        : - msg_id     - Kernel message ID number
 *                 - param      - Message parameter (unused)
 *                 - dest_id    - Destination task ID number
 *                 - src_id     - Source task ID number
 * Outputs       : return value - Indicate if the message was consumed;
 *                                compare with KE_MSG_CONSUMED
 * Assumptions   : None
 * */


int LED_Timer(ke_msg_id_t const msg_id,
              void const *param,
              ke_task_id_t const dest_id,
              ke_task_id_t const src_id)
{
    if (ble_env.state == APPM_CONNECTED)
    {
        Sys_GPIO_Set_High(LED_DIO_NUM);
    }
    else if (ble_env.state ==APPM_ADVERTISING)
    {
        Sys_GPIO_Toggle(LED_DIO_NUM);
    }
    else
    {
        Sys_GPIO_Set_Low(LED_DIO_NUM);
    }

    /* Reschedule timer */
    ke_timer_set(LED_TIMER, TASK_APP, TIMER_200MS_SETTING);

    return (KE_MSG_CONSUMED);
}


/*---------------------------------
 * Function      : int Msg_Handler(ke_msg_id_t const msg_id,
 *                                 void const *param,
 *                                 ke_task_id_t const dest_id,
 *                                 ke_task_id_t const src_id)
 * ----------------------------------------------------------------------------
 * Description   : Handle any message received from kernel that doesn't have
 *                 a dedicated handler
 * Inputs        : - msg_id     - Kernel message ID number
 *                 - param      - Message parameter (unused)
 *                 - dest_id    - Destination task ID number
 *                 - src_id     - Source task ID number
 * Outputs       : return value - Indicate if the message was consumed;
 *                                compare with KE_MSG_CONSUMED
 * Assumptions   : None
 * ------------------------------------------------------------------------- */
int Msg_Handler(ke_msg_id_t const msg_id, void *param,
                ke_task_id_t const dest_id, ke_task_id_t const src_id)
{
    return (KE_MSG_CONSUMED);
}



